'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PlayerManager = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlayerManager = exports.PlayerManager = function (_EventEmitter) {
  _inherits(PlayerManager, _EventEmitter);

  function PlayerManager(pluginClasses, config) {
    _classCallCheck(this, PlayerManager);

    var _this = _possibleConstructorReturn(this, (PlayerManager.__proto__ || Object.getPrototypeOf(PlayerManager)).call(this));

    _this.config = Object.assign({
      default: undefined,
      autoPause: false,
      autoResume: false
    }, config || {});
    _this.plugins = [];
    pluginClasses.forEach(function (PluginClass) {
      var obj = new PluginClass(_this, config);
      if (_this.validatePlugin(obj)) {
        _this.plugins.push(obj);
      } else {
        console.error('Media plugin ' + PluginClass.name + ' failed validation. It may be missing some required methods.');
      }
    });

    console.log('Loaded ' + _this.plugins.length + ' media plugins.');

    var maybeDefault = _this.plugins.find(function (x) {
      return x.playerName() === config.default;
    });
    if (!config.default || !maybeDefault) _this.setActivePlugin(_this.plugins[0]);else _this.setActivePlugin(maybeDefault);
    return _this;
  }

  _createClass(PlayerManager, [{
    key: 'setActivePlugin',
    value: function setActivePlugin(newPlugin) {
      if (this.currentPlugin) {
        this.currentPlugin.deactivate();
        this.currentPlugin.removeAllListeners();
      }

      this.currentPlugin = newPlugin;
      if (newPlugin) {
        newPlugin.activate();
      }

      this.emit('newPlugin', newPlugin);
    }
  }, {
    key: 'validatePlugin',
    value: function validatePlugin(pluginObject) {
      var requiredFunctions = ['playerName', 'iconUrl', 'activate', 'deactivate'];

      for (var i = 0; i < requiredFunctions.length; i++) {
        if (!(pluginObject[requiredFunctions[i]] instanceof Function)) {
          return false;
        }
      }

      return true;
    }
  }]);

  return PlayerManager;
}(_events.EventEmitter);