'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FooterFactory = undefined;

var _BackPlate = require('./BackPlate');

var _BackPlate2 = _interopRequireDefault(_BackPlate);

var _MediaBar = require('./MediaBar');

var _MediaBar2 = _interopRequireDefault(_MediaBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FooterFactory = exports.FooterFactory = function FooterFactory(React) {
  var BackPlate = (0, _BackPlate2.default)(React);
  var MediaBar = (0, _MediaBar2.default)(React);

  return function (_ref) {
    var playerManager = _ref.playerManager,
        hyperMedia = _ref.hyperMedia;
    return React.createElement(
      'footer',
      { className: 'hyper-media hoverable', style: footerStyle },
      React.createElement(BackPlate, null),
      React.createElement(MediaBar, { playerManager: playerManager, hyperMedia: hyperMedia })
    );
  };
};

var footerStyle = {
  position: 'absolute',
  right: 0,
  bottom: 0,
  left: 0,
  display: 'flex',
  justifyContent: 'center',
  alignItems: 'center',
  opacity: '0.5'
};