'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
function renderTimeSpan(timeSpan) {
  var tSec = timeSpan / 1000 >> 0;
  return (tSec / 60 >> 0) + ':' + ('0' + tSec % 60).slice(-2);
}

var TrackInfoFactory = function TrackInfoFactory(React) {
  return function (_ref) {
    var _ref$status = _ref.status,
        track = _ref$status.track,
        progress = _ref$status.progress;

    return React.createElement(
      'div',
      null,
      React.createElement(
        'b',
        null,
        track.name
      ),
      track.artist ? React.createElement(
        'span',
        null,
        ' by ',
        React.createElement(
          'b',
          null,
          track.artist
        )
      ) : '',
      React.createElement(
        'span',
        { style: { marginLeft: 5, display: track.duration && 'inline' || 'none' } },
        '(',
        progress ? React.createElement(
          'span',
          null,
          React.createElement(
            'b',
            null,
            renderTimeSpan(progress)
          ),
          ' / '
        ) : '',
        React.createElement(
          'b',
          null,
          renderTimeSpan(track.duration)
        ),
        ')'
      )
    );
  };
};

exports.default = TrackInfoFactory;