'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapHyperState = exports.reduceUI = exports.decorateConfig = exports.decorateHyper = exports.onRendererWindow = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _hyperPluginExtend = require('hyper-plugin-extend');

var _PlayerManager = require('./PlayerManager');

var _Footer = require('./components/Footer');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var parentPluginName = 'hyper-media-control';

var onRendererWindow = (0, _hyperPluginExtend.registerParentPlugin)(parentPluginName);

function decorateHyper(Hyper, _ref) {
  var React = _ref.React;

  var Footer = (0, _Footer.FooterFactory)(React);

  return function (_React$PureComponent) {
    _inherits(_class, _React$PureComponent);

    function _class(props) {
      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

      _this.playerManager = new _PlayerManager.PlayerManager((0, _hyperPluginExtend.getSubPlugins)(parentPluginName), _this.props.hyperMedia || {});
      return _this;
    }

    _createClass(_class, [{
      key: 'render',
      value: function render() {
        var existingInnerChildren = this.props.customInnerChildren;


        var customInnerChildren = existingInnerChildren ? existingInnerChildren instanceof Array ? existingInnerChildren : [existingInnerChildren] : [];

        if (this.playerManager.plugins.length > 0) customInnerChildren = [].concat(customInnerChildren, React.createElement(Footer, { playerManager: this.playerManager, hyperMedia: this.props.hyperMedia }));

        return React.createElement(Hyper, Object.assign({}, { customInnerChildren: customInnerChildren }, this.props));
      }
    }]);

    return _class;
  }(React.PureComponent);
}

function decorateConfig(config) {
  return Object.assign({}, config, {
    css: '\n        ' + (config.css || '') + '\n\n        .terms_terms {\n          margin-bottom: 30px;\n        }\n\n        .hyper-media.hoverable:hover,\n        .hyper-media .hoverable:hover {\n          opacity: 1 !important\n        }\n    '
  });
}

function reduceUI(state, _ref2) {
  var type = _ref2.type,
      config = _ref2.config;

  switch (type) {
    case 'CONFIG_LOAD':
    case 'CONFIG_RELOAD':
      return state.set('hyperMedia', config.hyperMedia);
  }

  return state;
}

function mapHyperState(_ref3, map) {
  var hyperMedia = _ref3.ui.hyperMedia;

  return Object.assign({}, map, {
    hyperMedia: Object.assign({}, hyperMedia)
  });
}

exports.onRendererWindow = onRendererWindow;
exports.decorateHyper = decorateHyper;
exports.decorateConfig = decorateConfig;
exports.reduceUI = reduceUI;
exports.mapHyperState = mapHyperState;